// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 Upon receiving a message with this object, Telegram clients will display a reply interface to the user (act as if the user has selected the bot‘s message and tapped ’Reply'). This can be extremely useful if you want to create user-friendly step-by-step interfaces without having to sacrifice privacy mode.

 SeeAlso Telegram Bot API Reference:
 [ForceReply](https://core.telegram.org/bots/api#forcereply)
 */
public final class ForceReply: Codable {

    /// Custom keys for coding/decoding `ForceReply` struct
    enum CodingKeys: String, CodingKey {
        case forceReply = "force_reply"
        case selective = "selective"
    }

    /// Shows reply interface to the user, as if they manually selected the bot‘s message and tapped ’Reply'
    public var forceReply: Bool = true

    /// Optional. Use this parameter if you want to force reply from specific users only. Targets: 1) users that are @mentioned in the text of the Message object; 2) if the bot's message is a reply (has reply_to_message_id), sender of the original message.
    public var selective: Bool?


    public init (forceReply: Bool = true, selective: Bool? = nil) {
        self.forceReply = forceReply
        self.selective = selective
    }
}
